#ifndef BSPLINE_H
#define BSPLINE_H


#include <QString>
#include <QGraphicsItem>
#include "model/Shape.h"
#include "model/Point.h"

class Bspline: public Shape {
public:
    Bspline();
    Bspline(QString, const QList<Point>&);

     //metodo que adiciona pontos a lista
    void addRPoint(const Point&);
    //metodo que calcula as coordenadas de ponto de projeção do objeto
    void calcCpp(double);
    //metodo que retorna a lista de pontos que formam a curva
    QList<Point> generatePoints(double acurracy);
    void saveXML(ofstream*);
    //metodo que atribui a lista de pontos da curva
    void setRPoints(QList<Point>);
    QList<Point> getRPoints();

private:
     //variavel que armazena os pontos que formam a bezier
     QList<Point> points;
};


#endif // BSPLINE_H
