#ifndef JANELAPRINCIPAL_H
#define JANELAPRINCIPAL_H

#include <QtGui/QMainWindow>
#include <QGraphicsView>
#include <QStringListModel>
#include "ui_janelaprincipal.h"

/**
 * \brief Classe de interface da janela principal.
 */
class JanelaPrincipal : public QMainWindow
{
    Q_OBJECT
public:
    JanelaPrincipal(QWidget *parent = 0);
    ~JanelaPrincipal();
    //Metodo que retorna a janela principal
    QGraphicsView* getCanvas();
    //Método responsável pela janela que mostra os itens
    void setListModel(QStringListModel*);

private:
    Ui::mainWindow ui;

private slots:
        //metodos de rotação
        void on_actionImportar_triggered();
        void on_actionSalvar_activated();
        void on_actionFechar_activated();
        void on_actionImportar_activated();
        void on_actionCurve_activated();
        void on_RotacionarD_clicked();
        void on_RotacionarE_clicked();
        //seleciona o objeto a ser transformado
        void on_objectList_clicked(QModelIndex index);
        //abre a janela de transformações se há um item selecionado
        void on_actionTransformar_activated();
        //Resposta ao clique no botão de navegação up
        void on_upButton_clicked();
        //Resposta ao clique no botão de navegação down
        void on_downButton_clicked();
        //Resposta ao clique no botão de navegação left
        void on_leftButton_clicked();
        //Resposta ao clique no botão de navegação right
        void on_rightButton_clicked();
        //Resposta ao clique na barra de menu na opção objeto ponto
        void on_actionPonto_activated();
        //Resposta ao clique na barra de menu na opção objeto Linha
        void on_actionLinha_activated();
        //Resposta ao clique na barra de menu na opção objeto Poligono
        void on_actionPoligono_activated();
        //Resposta ao clique no botão de zoomIn
        void on_zoomInButton_clicked();
        //Resposta ao clique no botão de zoomOut
        void on_zoomOutButton_clicked();
};



#endif // JANELAPRINCIPAL_H
