#include "transform.h"
#include "ui_transform.h"
#include <QDebug>

//metodo construtor
Transform::Transform(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::Transform)
{
    ui->setupUi(this);

}

//metodo destrutor
Transform::~Transform()
{
    delete ui;
}

//metodo que responde ao click do botão aplicar, na aba de rotação da janela de transformação
void Transform::on_btn_rota_clicked()
{
    Shape *forma;
    forma = Mediator::instance()->getSelectedItem();
    bool entrou = false;
    if(ui->rbt_sobreOrigem->isChecked())
    {
        Transformer::rotationOrigin(forma,ui->spb_Ang->value());
        Mediator::instance()->setSelectedItem(forma);
        entrou= true;
    }
    else if (ui->rtb_sobreCentro->isChecked())
    {
        Transformer::rotationCenter(forma,ui->spb_Ang->value());
        Mediator::instance()->setSelectedItem(forma);
        entrou= true;
    }
    else if (ui->rtb_sobrePonto->isChecked())
    {
        Transformer::rotationPointasRef(forma,ui->spb_Ang->value(),ui->spb_PX->value(),ui->spb_PY->value());
        Mediator::instance()->setSelectedItem(forma);
        entrou= true;
    }
    if(entrou)
    {
        forma->calcCpp(Mediator::instance()->getWindow()->getAngle());
        Mediator::instance()->redraw();
    }
}

//metodo que responde ao click do botão aplicar, na aba de translação da janela de transformação
void Transform::on_btn_Trans_clicked()
{
    Shape *forma;
    forma = Mediator::instance()->getSelectedItem();
    Transformer::translation(forma, ui->spb_TPX->value(), ui->spb_TPY->value());
    forma->calcCpp(Mediator::instance()->getWindow()->getAngle());
    Mediator::instance()->redraw();
}

//metodo que responde ao click do botão aplicar, na aba de escalonamento da janela de transformação
void Transform::on_btn_escalona_clicked()
{
    Shape *forma;
    forma = Mediator::instance()->getSelectedItem();
    Transformer::scale(forma, ui->dsb_scaX->value(), ui->dsb_scaY->value());
    forma->calcCpp(Mediator::instance()->getWindow()->getAngle());
    Mediator::instance()->redraw();
}


//metodo que responde ao click do botão palete de cores, na aba cor da janela de transformação abrindo o dialog de cores
void Transform::on_pushButton_clicked()
{
    QColorDialog *pallet = new QColorDialog(this);
    pallet->show();
    connect(pallet,SIGNAL(colorSelected(QColor)),this,SLOT(corEscolhida(QColor)));
}

//metodo que atuliza as spin box com a cor selecionada no dialog de cores
void Transform::corEscolhida(QColor pallet)
{
    ui->spb_R->setValue(pallet.red());
    ui->spb_B->setValue(pallet.blue());
    ui->spb_G->setValue(pallet.green());
}

//metodo que responde ao click do botão aplicar, na aba cor da janela de transformação aplicando a cor ao objeto
void Transform::on_btn_cor_clicked()
{
    Shape *forma;
    forma = Mediator::instance()->getSelectedItem();
    forma->setRGB( ui->spb_R->value(),ui->spb_G->value(),ui->spb_B->value());
    Mediator::instance()->redraw();
}
