#ifndef BEZIER_H
#define BEZIER_H

#include <QString>
#include <QGraphicsItem>
#include "Shape.h"
#include "Point.h"


class Bezier : public Shape {
public:
    Bezier();
    Bezier(QString, const QList<Point>&);
    virtual ~Bezier();
     //metodo que adiciona pontos a lista
    void addRPoint(const Point&);
    //metodo que calcula as coordenadas de ponto de projeção do objeto
    void calcCpp(double);
    //metodo que retorna a lista de pontos que formam a curva
    QList<Point> generatePoints(double acurracy);
    void saveXML(ofstream*);
    //metodo que atribui a lista de pontos da curva
    void setRPoints(QList<Point>);
    QList<Point> getRPoints();

private:
     //variavel que armazena os pontos que formam o poligono
     QList<Point> points;
};

#endif // BEZIER_H
