#include "Line.h"

//metodo construtor
Line::Line() : Shape(LINE) {
}

Line::Line(Point a, Point b) : Shape(LINE) {
	this->a = a;
	this->b = b;
}

Line::Line(QString id, Point a, Point b) : Shape(LINE) {
	Line(a,b);
	this->name = "l_" + id;
}

//metodo destrutor
Line::~Line() {
}

//metodo que retorna o ponto a da linha
Point Line::getA() {
	return a;
}

//metodo que retorna o ponto b da linha
Point Line::getB() {
	return b;
}


//metodo que retorna o ponteiro para o ponto a da linha
Point* Line::getAP() {
        return &a;
}

//metodo que retorna o ponteiro para o ponto b da linha
Point* Line::getBP() {
        return &b;
}



//metodo que atribui um ponto ao ponto a da linha
void Line::setA(Point* pa) {
        a = (*pa);
}

//metodo que atribui um ponto ao ponto b da linha
void Line::setB(Point* pb) {
        b = (*pb);
}

//metodo que calculo a coordenada de ponto de projeção do objeto
void Line::calcCpp(double angle)
{
    a.calcCpp(angle);
    b.calcCpp(angle);
}

//metodo que compara se uma linha é igual a outra linha em questão
bool Line::operator==(const Line &other) const {
	return (this->a == other.a && this->b == other.b);
}

//metodo que compara se uma linha é diferente da outra linha em questão
bool Line::operator!=(const Line &other) const {
	return !(*this == other);
}

void Line::saveXML(ofstream* f)
{
    std::stringstream ss;
    char saida[7];
    char p[2];
    p[0] = 0;
    p[1] = 0;
    p[2] = 0;
    if(this->R != 0){
        ss << std::hex << this->R;
        ss >> p;
        saida[0] = p[0];
        saida[1] = p[1];
        ss.clear();
    }else{
     saida[0] = '0';
     saida[1] = '0';
    }
    if(this->G != 0){
        ss << std::hex << this->G;
        ss >> p;
        saida[2] = p[0];
        saida[3] = p[1];
        ss.clear();
    }else
    {
        saida[2] = '0';
        saida[3] = '0';
    }
    if(this->B != 0){
        ss << std::hex<< this->B;
        ss >> p;
        saida[4] = p[0];
        saida[5] = p[1];
    }else
    {
        saida[4] = '0';
        saida[5] = '0';
    }
    saida[6] = 0;
    (*f)<<"\n\t<reta nome=\"";
    (*f)<<this->name.toStdString();
    (*f)<<"\" cor=\"";
    (*f)<<saida<<"\">\n";
     this->a.xmlPonto(f);
     this->b.xmlPonto(f);
    (*f)<<"\t</reta>";
}
