#ifndef SHAPE_H_
#define SHAPE_H_

#include <QGraphicsItem>
#include <QString>
#include <iostream>
#include <fstream>
#include <sstream>
using namespace std;


/**
 * Enum com os tipos possíveis de formas geométricas.
 */
enum shape_t {
        POINT, LINE, POLYGON, BEZIER, BSPLINE
};

/**
 * \brief Superclasse de todas as formas geométricas. Possui nome
 * e um tipo, que é determinado pela subclasse.
*/
class Shape {
public:
	Shape();
	Shape(shape_t);

	/// Obtém o tipo de uma forma geométrica
	shape_t getType() const;

	/// Obtém o nome do objeto. É vazio caso tenha sido usado um construtor sem passar o nome
	QString getName() const;

	/// Altera o nome do objeto
	void setName(QString);

        //metodo que realiza o calculo do ccp dos objetos
        virtual void calcCpp(double) = 0;

        //metodo que realiza o calculo do ccp dos objetos
        virtual void saveXML(ofstream*) = 0;

        //variaveis que guarda a cor em tons de vermelho, azul  e verde RGB
        int R,G,B;

        //metod que atribui a cor do objeto
        void setRGB(int R, int G, int B);

	virtual ~Shape();
protected:
        //variavel que armazena o tipo de formato do objeto
	shape_t type;
        //variavel que armazena o nome do objeto
	QString name;


};

#endif /* SHAPE_H_ */
