#ifndef XMLLOADER_H
#define XMLLOADER_H

#ifdef TIXML_USE_STL
        #include <iostream>
        #include <sstream>
        using namespace std;
#else
        #include <stdio.h>
#endif


#include "tinyxml/tinyxml.h"
#include "Point.h"
#include "Line.h"
#include "Polygon.h"
#include "Bezier.h"
#include "bspline.h"

class XMLLoader
{
public:
    XMLLoader();
    virtual ~XMLLoader();
    static Point constructPoint(TiXmlElement& pElem);
    static void constructOnePoint(TiXmlHandle hElem);
    static void constructReta(TiXmlHandle hElem);
    static void constructPoligono(TiXmlHandle hElem);
    static void constructBez(const char *,TiXmlHandle hElem,const char*);
    static void constructSpline(TiXmlHandle hElem);
    static void shapesAtLevel(TiXmlHandle handle);
    static void processShapes(TiXmlDocument& doc);
};

#endif // XMLLOADER_H
